<?php
add_filter('wpjam_template', function($wpjam_template, $module){
	if($module == 'user'){
		return get_template_directory().'/user/index.php';
	}
	return $wpjam_template;
}, 10, 2);


add_filter('wpjam_rewrite_rules', function ($rules){
	$rules['user/posts/page/?([0-9]{1,})$']	= 'index.php?module=user&action=posts&paged=$matches[1]';
	$rules['user/([^/]+)$']					= 'index.php?module=user&action=$matches[1]';
	$rules['user/page/?([0-9]{1,})$']		= 'index.php?module=user&action=posts&paged=$matches[1]';
	$rules['user$']							= 'index.php?module=user&action=posts';

	return $rules;
});

if( wpjam_get_setting('wpjam_theme', 'foot_link') ) {
	add_filter('pre_option_link_manager_enabled', '__return_true');	/*激活友情链接后台*/
}

//禁止代码标点转换
remove_filter('the_content', 'wptexturize');
//载入JS\CSS
add_action('wp_enqueue_scripts', function () {

	if (!is_admin()) {
		
		wp_enqueue_style('style', get_stylesheet_directory_uri().'/static/css/style.css');
		wp_enqueue_style('fonts', get_stylesheet_directory_uri().'/static/fonts/iconfont.css');

		//wp_enqueue_script('jquery',			get_stylesheet_directory_uri() . '/static/js/jquery.js');
		wp_enqueue_script('autumn',	get_stylesheet_directory_uri() . '/static/js/autumn.min.js', ['jquery'], '', true);
		wp_localize_script( 'autumn', 'site_url', array("home_url"=>get_option('home'),"admin_url"=>admin_url("admin-ajax.php") ) );
		
        wp_deregister_script('jquery');
        wp_register_script('jquery', "https://cdn.bootcss.com/jquery/3.1.1/jquery.min.js", false, null);
        wp_enqueue_script('jquery');
        wp_deregister_script('jquery-migrate');
        wp_register_script('jquery-migrate', "https://cdn.bootcss.com/jquery-migrate/3.0.0/jquery-migrate.min.js", false, null);
        wp_enqueue_script('jquery-migrate');

	}
	if (is_single()) {
		wp_enqueue_style('fancybox', get_stylesheet_directory_uri().'/static/fancybox/jquery.fancybox.min.css');
		wp_enqueue_script('fancybox3', get_stylesheet_directory_uri() . '/static/fancybox/jquery.fancybox.min.js', ['jquery'], '', true);
	}
});

//文章列表 AJAX加载
function xintheme_load_more_scripts() {
	global $wp_query; 

	$paging = wpjam_get_setting('wpjam_theme', 'paging_xintheme');
	if( $paging == '3' ){
		wp_register_script( 'xintheme_loadmore', get_stylesheet_directory_uri() . '/static/js/myloadmore.js', array('jquery'), '', true );
	}
	if( $paging == '4' ){
		wp_register_script( 'xintheme_loadmore', get_stylesheet_directory_uri() . '/static/js/myloadmore-2.js', array('jquery'), '', true );
	}
	wp_localize_script( 'xintheme_loadmore', 'misha_loadmore_params', array(
		'ajaxurl' => site_url() . '/wp-admin/admin-ajax.php', // WordPress AJAX
		'posts' => json_encode( $wp_query->query_vars ), // everything about your loop is here
		'current_page' => get_query_var( 'paged' ) ? get_query_var('paged') : 1,
		'max_page' => $wp_query->max_num_pages
	) );
 
 	wp_enqueue_script( 'xintheme_loadmore' );
}
 
add_action( 'wp_enqueue_scripts', 'xintheme_load_more_scripts' );

//文章加载 主循环
function xintheme_loadmore_ajax_handler(){
 
	$args = json_decode( stripslashes( $_POST['query'] ), true );
	$args['paged'] = $_POST['page'] + 1; // we need next page to be loaded
	$args['post_status'] = 'publish';
	$args['ignore_sticky_posts'] = 1;
 
	query_posts( $args );
 
	if( have_posts() ) :
 
		while( have_posts() ): the_post();
 
			get_template_part( 'template-parts/content-list' );
 
		endwhile;
 
	endif;
	die; 
}
 
add_action('wp_ajax_loadmore', 'xintheme_loadmore_ajax_handler'); // wp_ajax_{action}
add_action('wp_ajax_nopriv_loadmore', 'xintheme_loadmore_ajax_handler'); // wp_ajax_nopriv_{action}

//删除菜单多余css class
function wpjam_css_attributes_filter($classes) {
	return is_array($classes) ? array_intersect($classes, array('current-menu-item','current-post-ancestor','current-menu-ancestor','current-menu-parent','menu-item-has-children','menu-item')) : '';
}
add_filter('nav_menu_css_class',	'wpjam_css_attributes_filter', 100, 1);
add_filter('nav_menu_item_id',		'wpjam_css_attributes_filter', 100, 1);
add_filter('page_css_class', 		'wpjam_css_attributes_filter', 100, 1);

if( wpjam_get_setting('wpjam_theme', 'xintheme_article') ) {
	add_filter('login_redirect', function ($redirect_to, $request){
		if( empty( $redirect_to ) || $redirect_to == 'wp-admin/' || $redirect_to == admin_url() ){
			return home_url("/wp-admin/edit.php");
		}else{
			return $redirect_to;
		}

	}, 10, 3);
}

//删除wordpress默认相册样式
add_filter( 'use_default_gallery_style', '__return_false' );

add_filter('wpjam_post_thumbnail_uri', function($post_thumbnail_uri, $post){
	if(get_post_meta($post->ID, 'header_img', true)){
		return get_post_meta($post->ID, 'header_img', true);
	}elseif($post_thumbnail_uri){
		return $post_thumbnail_uri;
	}else{
		return wpjam_get_post_first_image($post->post_content);
	}
},10,2);

add_filter('wpjam_default_thumbnail_uri',function ($default_thumbnail){
	$default_thumbnails	= wpjam_get_setting('wpjam_theme', 'thumbnails');

	if($default_thumbnails){
		shuffle($default_thumbnails);
		return $default_thumbnails[0];
	}else{
		return $default_thumbnail;
	}
},99);

/* 评论作者链接新窗口打开 */
add_filter('get_comment_author_link', function () {
	$url	= get_comment_author_url();
	$author = get_comment_author();
	if ( empty( $url ) || 'http://' == $url ){
		return $author;
	}else{
		return "<a target='_blank' href='$url' rel='external nofollow' class='url'>$author</a>";
	}
});

/* 搜索关键词为空 */
add_filter( 'request', function ( $query_variables ) {
	if (isset($_GET['s']) && !is_admin()) {
		if (empty($_GET['s']) || ctype_space($_GET['s'])) {
			wp_redirect( home_url() );
			exit;
		}
	}
	return $query_variables;
} );

//文章自动nofollow
add_filter( 'the_content', function ( $content ) {
	//fancybox3图片添加 data-fancybox
    global $post;
    $pattern = "/<a(.*?)href=('|\")([^>]*).(bmp|gif|jpeg|jpg|png|swf)('|\")(.*?)>(.*?)<\/a>/i";
    $replacement = '<a$1href=$2$3.$4$5 data-fancybox="images" $6>$7</a>';
    $content = preg_replace($pattern, $replacement, $content);
	//文章自动nofollow
	$regexp = "<a\s[^>]*href=(\"??)([^\" >]*?)\\1[^>]*>";
	if(preg_match_all("/$regexp/siU", $content, $matches, PREG_SET_ORDER)) {
		if( !empty($matches) ) {
   
			$srcUrl = get_option('siteurl');
			for ($i=0; $i < count($matches); $i++)
			{
				$tag = $matches[$i][0];
				$tag2 = $matches[$i][0];
				$url = $matches[$i][0];
   
				$noFollow = '';
				$pattern = '/target\s*=\s*"\s*_blank\s*"/';
				preg_match($pattern, $tag2, $match, PREG_OFFSET_CAPTURE);
				if( count($match) < 1 )
					$noFollow .= ' target="_blank" ';
   
				$pattern = '/rel\s*=\s*"\s*[n|d]ofollow\s*"/';
				preg_match($pattern, $tag2, $match, PREG_OFFSET_CAPTURE);
				if( count($match) < 1 )
					$noFollow .= ' rel="nofollow" ';
   
				$pos = strpos($url,$srcUrl);
				if ($pos === false) {
					$tag = rtrim ($tag,'>');
					$tag .= $noFollow.'>';
					$content = str_replace($tag2,$tag,$content);
				}
			}
		}
	}
	$content = str_replace(']]>', ']]>', $content);
	return $content;
});

add_filter('the_excerpt',function($post_excerpt){
	global $post;
	if($post_abstract = get_post_meta($post->ID, 'post_abstract', true)){
		return mb_strimwidth($post_abstract, 0, 115, '...');
	}else{
		return get_post_excerpt($post, 115);
	}
});

//修复 WordPress 找回密码提示“抱歉，该key似乎无效”
add_filter('retrieve_password_message', function ( $message, $key ) {
	if ( strpos($_POST['user_login'], '@') ) {
		$user_data = get_user_by('email', trim($_POST['user_login']));
	} else {
		$login = trim($_POST['user_login']);
		$user_data = get_user_by('login', $login);
	}
	
	$user_login = $user_data->user_login;
	$msg	= __('有人要求重设如下帐号的密码：'). "\r\n\r\n";
	$msg	.= network_site_url() . "\r\n\r\n";
	$msg	.= sprintf(__('用户名：%s'), $user_login) . "\r\n\r\n";
	$msg	.= __('若这不是您本人要求的，请忽略本邮件，一切如常。') . "\r\n\r\n";
	$msg	.= __('要重置您的密码，请打开下面的链接：'). "\r\n\r\n";
	$msg	.= network_site_url("wp-login.php?action=rp&key=$key&login=" . rawurlencode($user_login), 'login') ;

	return $msg;
}, null, 2);


//禁止FEED
if( wpjam_get_setting('wpjam_theme', 'xintheme_feed') ) {
	function wpjam_disable_feed() {
		wp_die(__('<h1>Feed已经关闭, 请访问网站<a href="'.get_bloginfo('url').'">首页</a>!</h1>'));
	}

	add_action('do_feed',		'wpjam_disable_feed', 1);
	add_action('do_feed_rdf',	'wpjam_disable_feed', 1);
	add_action('do_feed_rss',	'wpjam_disable_feed', 1);
	add_action('do_feed_rss2',	'wpjam_disable_feed', 1);
	add_action('do_feed_atom',	'wpjam_disable_feed', 1);
}

add_filter('pre_get_avatar_data', function($args, $id_or_email){
	if(is_numeric($id_or_email)){
		if($photo	= get_user_meta($id_or_email, 'photo', true)){
			$args['url'] = wpjam_get_thumbnail($photo, [$args['width'], $args['height']]);
		}
	}

	return $args;
},10,2);


//使用v2ex镜像avatar头像
if( wpjam_get_setting('wpjam_theme', 'xintheme_v2ex') ) {
	add_filter('get_avatar', function ($avatar, $id_or_email, $size){
		return str_replace(['cn.gravatar.com/avatar', 'secure.gravatar.com/avatar', '0.gravatar.com/avatar', '1.gravatar.com/avatar', '2.gravatar.com/avatar'], 'cdn.v2ex.com/gravatar', $avatar);
	}, 10, 3 );
}

add_action('wp_head', function (){
	if (is_singular()) { 
		global $post;
		wpjam_update_post_views($post->ID);
	}
}); 
//点赞
function dotGood(){  
    global $wpdb, $post;  
    $id = $_POST["um_id"];  
    if ($_POST["um_action"] == 'topTop') {  
        $specs_raters = get_post_meta($id, 'dotGood', true);  
        $expire = time() + 99999999;  
        $domain = ($_SERVER['HTTP_HOST'] != 'localhost') ? $_SERVER['HTTP_HOST'] : false; // make cookies work with localhost  
        setcookie('dotGood_' . $id, $id, $expire, '/', $domain, false);  
        if (!$specs_raters || !is_numeric($specs_raters)) update_post_meta($id, 'dotGood', 1);  
        else update_post_meta($id, 'dotGood', ($specs_raters + 1));  
        echo get_post_meta($id, 'dotGood', true);  
    }  
    die;  
}  
add_action('wp_ajax_nopriv_dotGood', 'dotGood');  
add_action('wp_ajax_dotGood', 'dotGood');

//投稿
add_action( 'wp_ajax_publish_post' , function (){

    global $wpdb;
    $user_id = get_current_user_id();
    $post_id = sanitize_text_field($_POST['post_id']);
    $post_status = sanitize_text_field($_POST['post_status']);
    $thumbnail = sanitize_text_field($_POST['thumbnail']);

    if( $post_id ){

        $old_post = $wpdb->get_var( $wpdb->prepare("SELECT * FROM $wpdb->posts WHERE ID = %s AND post_author = %s AND post_type = 'post'" , $post_id , $user_id) );

        if( $old_post ){
            $my_post = array(
                'ID'            => $post_id,
                'post_title'    => wp_strip_all_tags( $_POST['post_title'] ),
                'post_content'  => $_POST['editor'],
                'post_status'   => $post_status,
                'post_author'   => $user_id,
                'post_category' => $_POST['cats']
            );
            wp_update_post( $my_post );
            set_post_thumbnail( $post_id, $thumbnail );

            $msg = array(
                'state' => 200,
                'tips' => '文章更新成功！',
                'url' => home_url(user_trailingslashit('/user'))
            );

        }

    }else{

        $my_post = array(
            'post_title'    => wp_strip_all_tags( $_POST['post_title'] ),
            'post_content'  => $_POST['editor'],
            'post_status'   => $post_status,
            'post_author'   => $user_id,
            'post_category' => $_POST['cats']
        );

        $post_id = wp_insert_post( $my_post );

        if( $post_id && $thumbnail ){
            set_post_thumbnail( $post_id, $thumbnail );
        }

        if( $post_id ){
            $msg = array(
                'state' => 200,
                'tips' => '文章提交成功',
                'url' => home_url(user_trailingslashit('/user'))
            );
            add_post_meta($post_id, 'tg' , $user_id);
        }else{
            $msg = array(
                'state' => 201,
                'tips' => '提交失败，请稍候再试'
            );  
        }

    }

    echo json_encode($msg);
    die();
} );

function wpjam_login_default_settings($value){
  if(empty($value['login_head'])){
    $value['login_head']  = '<link rel="stylesheet" type="text/css" href="' . get_bloginfo('template_directory') . '/static/css/login.css" />'."\n";
    $value['login_head'] .= '<script type="text/javascript" src="//dn-staticfile.qbox.me/jquery/2.1.4/jquery.min.js"></script>'."\n";
  }

  if(empty($value['login_footer'])){
    $value['login_footer'] = '<div class="footer">'."\n";
    $value['login_footer'] .= '<p>Copyright &copy; '.date('Y').' All Rights | Powered by <a href="http://www.xintheme.com" target="_blank">XinTheme</a>&nbsp;+&nbsp;<a href="https://blog.wpjam.com/" target="_blank">WordPress 果酱</a></p>'."\n";
    $value['login_footer'] .=  '</div>'."\n";
    $value['login_footer'] .=  '<script type="text/javascript" src="'.get_bloginfo('template_directory').'/static/js/resizeBg.js"></script>'."\n";
    $value['login_footer'] .=  '<script type="text/javascript">'."\n";
    $value['login_footer'] .=  'jQuery("body").prepend("<div class=\"loading\"><img src=\"'.get_bloginfo('template_directory').'/static/images/login_loading.gif\" width=\"58\" height=\"10\"></div><div id=\"bg\"><img /></div>");'."\n";
    $value['login_footer'] .=  'jQuery(\'#bg\').children(\'img\').attr(\'src\', \''.get_bloginfo('template_directory').'/static/images/login_bg.jpg\').load(function(){'."\n";
    $value['login_footer'] .=  '  resizeImage(\'bg\');'."\n";
    $value['login_footer'] .=  '  jQuery(window).bind("resize", function() { resizeImage(\'bg\'); });'."\n";
    $value['login_footer'] .=  '  jQuery(\'.loading\').fadeOut();'."\n";
    $value['login_footer'] .=  '});';
    $value['login_footer'] .=  '</script>'."\n";
  }

  return $value;
}
add_filter('option_wpjam-basic', 'wpjam_login_default_settings');
add_filter('default_option_wpjam-basic', 'wpjam_login_default_settings');

//在[媒体库]只显示用户上传的文件
add_filter('parse_query',  function( $wp_query ) {
    if ( strpos( $_SERVER[ 'REQUEST_URI' ], '/wp-admin/upload.php' ) !== false ) {
        if ( !current_user_can( 'manage_options' ) && !current_user_can( 'manage_media_library' ) ) {
            global $current_user;
            $wp_query->set( 'author', $current_user->id );
        }
    }
});

add_action('pre_get_posts',  function($wp_query) {
	global $current_user, $pagenow;

	if($wp_query->is_main_query()){

		if(is_module('user', 'posts')){
			$wp_query->set('ignore_sticky_posts', true);
			$wp_query->set('post_type', 'post');
			$wp_query->set('post_status', 'any');
			$wp_query->set('author',  $current_user->ID);
		}elseif(is_home()){
			$wp_query->set('ignore_sticky_posts',true);
		}elseif(is_search()){
			$wp_query->set('post_type', 'post');	//搜索结果排除所有页面
		}
	}elseif($pagenow == 'admin-ajax.php' && $_REQUEST['action'] == 'query-attachments'){	//在文章编辑页面的[添加媒体]只显示用户自己上传的文件
		if(current_user_can('manage_options') && current_user_can('manage_media_library')){
			$wp_query->set('author', $current_user->ID );
		}
	}

	return $wp_query;
});

function wpjam_xintheme_apis($value){
	$value	= $value?:[];
	
	$value['post.list']	= [
		'json'			=> 'post.list',
		'auth'			=> false,
		'title'			=> '文章列表',
		'modules'		=> wpjam_xintheme_get_post_list_modules()
	];

	$value['post.get']	= [
		'json'			=> 'post.get',
		'auth'			=> false,
		'title'			=> '文章详情',
		'modules'		=> [
			[
				'type'	=> 'post_type',
				'args'	=> '[module action="get" output="post"]'
			]
		]
	];

	return $value;
}
add_filter('option_wpjam_apis', 'wpjam_xintheme_apis');
add_filter('default_option_wpjam_apis', 'wpjam_xintheme_apis');

function wpjam_xintheme_get_post_list_modules(){
	if(wpjam_get_json() != 'post.list'){
		return [];
	}

	$modules	= [];

	if(empty($_GET['category_id']) && empty($_GET['tag_id']) && empty($_GET['post_author']) && empty($_GET['paged']) && empty($_GET['cursor'])){
		$sticky_posts	= get_option('sticky_posts');
		$modules[]		= [
			'type'	=> 'post_type',
			'args'	=> ['post_type'=>'post', 'action'=>'list', 'posts_per_page'=>10, 'post__in'=>$sticky_posts, 'sticky_posts'=>true, 'output'=>'sticky_posts']
		];
	} 

	$modules[]		= [
		'type'	=> 'post_type',
		'args'	=> ['post_type'=>'post', 'action'=>'list', 'posts_per_page'=>10]
	];

	return $modules;
}


add_filter('wpjam_post_json', function($post_json, $post_id, $post_type_setting, $args){
	global $post;
	$post	= get_post($post_id);

	$feature_list	= intval(get_post_meta($post_id, 'feature_list', true));
	$post_json['feature_list']	= $feature_list;

	if(!empty($args['sticky_posts'])){
		$size	= [670, 670];
	}else{
		$size	= $feature_list ? [670, 670] : [670,415];
	}
	$post_json['thumbnail']		= wpjam_get_post_thumbnail_src($post,$size);
	
	$post_author	= get_userdata($post->post_author);
	$post_json['author']		= [
		'id'	=> $post_author->id,
		'user_login'	=> $post_author->user_login,
		'display_name'	=> $post_author->display_name,
		'avatar'		=> get_avatar_url($post_author->user_email, ['size'=>60])
	];

	$post_json['permalink']		= get_permalink($post_id);

	if(is_single()){
		$post_json['content']	= wpjam_content_images($post_json['content'], 1200, false);
		$post_json['related']	= WPJAM_PostTypeSetting::get_related($post_id);
	}

	return $post_json;

}, 10, 4);
